; CS 363 - Lab #6 - Let's write some of our own Scheme/Lisp functions to
; get a taste of functional programming.
;
; From the server, copy the "lab 6" folder to your machine.
; This folder contains a Scheme interpreter called SISC.
; If you want to refer to examples we did in class, you can look
; at 1.scm and 2.scm.
; This file is called lab6.scm.  So, here is how you would run this
; program:  open a command prompt, and navigate to the lab 6 directory.
; Then enter this command:
;     sisc < lab6.scm
; and you will see the output on the screen.  If you run the program now,
; the output is all zero because the functions haven't yet been implemented.
; The suggested correct output can be found in a file called correct_output.txt.
;
; This source file is organized into 3 parts
;   - function implementations (you need to work on this section)
;   - define some lists for testing
;   - testing the functions for output
;
; In this lab, you will define and test out the following functions:
; 1.  removeNegative - Given a list of numbers, take out the negative values.
; 2.  firstTwo - Given a list, return a list containing just first 2 values.
; 3.  countDown - Given a positive number n, return a list of consecutive
;     numbers in descending order n..1.
; 4.  countUp - Given a positive number n, return a list of numbers 1..n.
; 5.  prop2assoc - Given a property list, convert it to an association list.
; 6.  assocKeysOnly - Given an association list, return a list showing only
;     the keys.  For example, if we are given ((a 1) (b 2)), we return (a b).
; 7.  assoc2prop - Given an assocation list, convert to property list.
; 8.  add_assoc - Given an assoc. list and an ordered pair (an association), 
;     add the association to the list.
; 9.  remove_assoc - Given an association list and a key (first item in
;     in an ordered pair), remove the corresponding association from the list.
; 10.  get_year - Given an association list for an employee record, return the
;      year that person was hired:  look for the key word "hire" and then
;      in the value, return the 3rd item from the sublist.
; 11.  get_assoc - Return one of the values from an association list.  You'll
;      be given the association list and the key to search for e.g. 'age.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Implement functions here
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define removeNegative
  (lambda (L)
    0
  )
)

; Hint:  It may be helpful to have a reverse function when 
; working on the function to count in ascending order.
(define reverse
  (lambda (L)
    0
  )
)

(define countDown
  (lambda (n)
    0
  )
)

(define countUp
  (lambda (n)
    0
  )
)

; Good practice to get ready for prop2assoc!
(define first_two
  (lambda (L)
    0
  )
)

; The given list L will have an even number of elements.  Pair them up.
(define prop2assoc
  (lambda (L)
     0
  )
)

(define assocKeysOnly
  (lambda (L)
    0
  )
)

; Given a list of pairs of elements, get everybody out of the pairs
; e.g. ((1 2) (3 4)) --> (1 2 3 4)
(define assoc2prop
  (lambda (L)
    0
  )
)

; add_assoc - Add an association (i.e. ordered pair) to an association list.
; This is pretty easy because the order of the pairs does not matter.
(define add_assoc
  (lambda (list pair)
    0
  )
)

; remove_assoc - Given an association list and a key (first item in
; in an ordered pair), remove the corresponding association from the list.
(define remove_assoc
  (lambda (list key)
    0
  )
)

; L is an association list.  Find the key "hire", and then return
; the 3rd element from its corresponding value.
(define get_year
  (lambda (L)
     0
  )
)

(define get_assoc
  (lambda (L key)
    0
  )
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Define some lists
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(define number_list '(5 -2 0 -8 4))

; records 1 and 2 are property lists
(define record1 '(name (John Doe) salary 25000 age 51 hire (June 10 1989)))
(define record2 '(salary 16000 name (Sam Coetzer) hire (May 22 1996) age 30))

; records 3 and 4 are assocation lists
(define record3 '((age 41)(name (Bob Gette))(hire (May 1 1968))(salary 38000)))
(define record4 '((salary 90000)(hire (January 5 2000))(name (Jill Beach))(age 50)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Testing the functions
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(display "\nMy list of numbers has:\n")
number_list

(display "After removing the negative values:\n")
(removeNegative number_list)

(display "Here is the original list again.\n")
number_list

(display "Here is a list containing the first two values.\n")
(first_two number_list)

(display "\nLet's count from 1 to 12...\n")
(countUp 12)
(countDown 12)

(display "\nHere's record 1 as an association list:\n")
(prop2assoc record1)

(display "\nHere are the keys of record 3:\n")
(assocKeysOnly record3)

(display "\nHere's record 4 converted to property list:\n")
(assoc2prop record4)

(display "\nLet's make Jill the vice-president:\n")
(add_assoc record4 '(title vice-president))

(display "\nLet's make Sam the secretary:\n")
(add_assoc (prop2assoc record2) '(title secretary))

(display "\nWithout showing salary, here is Bob:\n")
(remove_assoc record3 'salary)

(display "\nIn what year did we hire John?\n")
(get_year (prop2assoc record1))

(display "\nWhat is employee 4's name?\n")
(get_assoc record4 'name)